'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = loader;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _pegjs = require('pegjs');

var _pegjs2 = _interopRequireDefault(_pegjs);

var _loaderUtils = require('loader-utils');

var _loaderUtils2 = _interopRequireDefault(_loaderUtils);

function loader(source) {
  if (this.cacheable) {
    this.cacheable();
  }

  var query = _loaderUtils2['default'].parseQuery(this.query);
  var cacheParserResults = !!query.cache;
  var optimizeParser = query.optimize || 'speed';
  var trace = !!query.trace;

  var allowedStartRules = undefined;
  if (typeof query.allowedStartRules === 'string') {
    allowedStartRules = [query.allowedStartRules];
  } else if (Array.isArray(query.allowedStartRules)) {
    allowedStartRules = query.allowedStartRules;
  } else {
    allowedStartRules = [];
  }

  // Description of PEG.js options: https://github.com/pegjs/pegjs#javascript-api
  var pegOptions = {
    output: 'source',
    cache: cacheParserResults,
    optimize: optimizeParser,
    trace: trace
  };
  if (allowedStartRules.length > 0) {
    pegOptions.allowedStartRules = allowedStartRules;
  }

  return 'module.exports = ' + _pegjs2['default'].buildParser(source, pegOptions) + ';';
}

module.exports = exports['default'];